package com.zulutrade.sample.trading.client.trading;

public class ZuluTradingRequestGeneratorImpl implements ZuluTradingRequestGenerator {

	@Override
	public String getOpenMarketRequest(String currencyName, Double lots, Boolean buy, Double requestedPrice, String uniqueId) {
		StringBuilder sb = new StringBuilder("open/market/");	
		sb.append("?");
		sb.append("currencyName=");
		sb.append(currencyName);
		sb.append("&lots=");
		sb.append(lots);
		sb.append("&buy=");
		sb.append(buy);
		sb.append("&requestedPrice=");
		sb.append(requestedPrice);		
		sb.append("&uniqueId=");
		sb.append(uniqueId);		
		return sb.toString();
	}

	@Override
	public String getCloseMarketRequest(String currencyName, Double lots, Boolean buy, Double requestedPrice, String uniqueId) {
		StringBuilder sb = new StringBuilder("close/market/");	
		sb.append("?");
		sb.append("currencyName=");
		sb.append(currencyName);
		sb.append("&buy=");
		sb.append(buy);
		sb.append("&lots=");
		sb.append(lots);
		sb.append("&uniqueId=");
		sb.append(uniqueId);	
		sb.append("&requestedPrice=");
		sb.append(requestedPrice);		
		return sb.toString();
	}

	@Override
	public String getOpenOrderRequest(String currencyName, Double lots, Boolean buy, Double requestedPrice, String uniqueId) {
		StringBuilder sb = new StringBuilder("open/pending/");	
		sb.append("?");
		sb.append("currencyName=");
		sb.append(currencyName);
		sb.append("&lots=");
		sb.append(lots);
		sb.append("&buy=");
		sb.append(buy);
		sb.append("&requestedPrice=");
		sb.append(requestedPrice);		
		sb.append("&uniqueId=");
		sb.append(uniqueId);		
		return sb.toString();
	}

	@Override
	public String getCancelOrderRequest(String currencyName, Double lots, Boolean buy, String uniqueId) {
		StringBuilder sb = new StringBuilder("close/pending/");	
		sb.append("?");
		sb.append("currencyName=");
		sb.append(currencyName);
		sb.append("&lots=");
		sb.append(lots);
		sb.append("&buy=");
		sb.append(buy);
		sb.append("&uniqueId=");
		sb.append(uniqueId);	
		return sb.toString();
	}

	@Override
	public String getUpdateLimitRequest(String currencyName, Boolean buy, Double lots, String uniqueId, Double limitValue) {
		StringBuilder sb = new StringBuilder("update/limit/");	
		sb.append("?");
		sb.append("currencyName=");
		sb.append(currencyName);
		sb.append("&lots=");
		sb.append(lots);
		sb.append("&buy=");
		sb.append(buy);
		sb.append("&uniqueId=");
		sb.append(uniqueId);
		sb.append("&limitValue=");
		sb.append(limitValue);
		return sb.toString();
	}

	@Override
	public String getUpdateStopRequest(String currencyName, Boolean buy, Double lots, String uniqueId, Double stopValue) {
		StringBuilder sb = new StringBuilder("update/stop/");	
		sb.append("?");
		sb.append("currencyName=");
		sb.append(currencyName);
		sb.append("&lots=");
		sb.append(lots);
		sb.append("&buy=");
		sb.append(buy);
		sb.append("&uniqueId=");
		sb.append(uniqueId);
		sb.append("&stopValue=");
		sb.append(stopValue);
		return sb.toString();
	}

	@Override
	public String getUpdateEntryRateRequest(String currencyName, Boolean buy, Double lots, String uniqueId, Double entryRate) {
		StringBuilder sb = new StringBuilder("update/entry/");	
		sb.append("?");
		sb.append("currencyName=");
		sb.append(currencyName);
		sb.append("&lots=");
		sb.append(lots);
		sb.append("&buy=");
		sb.append(buy);
		sb.append("&uniqueId=");
		sb.append(uniqueId);
		sb.append("&entryValue=");
		sb.append(entryRate);
		return sb.toString();
	}
	
	@Override
	public String getGetOpenTradesRequest() {
		StringBuilder sb = new StringBuilder("getOpen");
		return sb.toString();
	}

	@Override
	public String getUpdateTrailingStopRequest(String currencyName, Boolean buy, Double lots, String uniqueId, Integer trailingStopValue) {
		StringBuilder sb = new StringBuilder("update/stop/trailing/");	
		sb.append("?");
		sb.append("currencyName=");
		sb.append(currencyName);
		sb.append("&lots=");
		sb.append(lots);
		sb.append("&buy=");
		sb.append(buy);
		sb.append("&uniqueId=");
		sb.append(uniqueId);
		sb.append("&trailingStopValue=");
		sb.append(trailingStopValue);
		return sb.toString();
	}
	
	@Override
	public String getUpdateTrailingStopConditionRequest(String currencyName, Boolean buy, Double lots, String uniqueId,	Integer trailingStopValue, Integer tralingStopConditionPips) {
		StringBuilder sb = new StringBuilder("update/stop/trailingCondition/");	
		sb.append("?");
		sb.append("currencyName=");
		sb.append(currencyName);
		sb.append("&lots=");
		sb.append(lots);
		sb.append("&buy=");
		sb.append(buy);
		sb.append("&uniqueId=");
		sb.append(uniqueId);
		sb.append("&trailingStopValue=");
		sb.append(trailingStopValue);
		sb.append("&trailingStopConditionPipsValue=");
		sb.append(tralingStopConditionPips);
		return sb.toString();
	}

	@Override
	public String getTradingConfigurationRequest() {
		StringBuilder sb = new StringBuilder("getTradingConfiguration");
		return sb.toString();
	}

	@Override
	public String getProviderStatisticsRequest() {
		StringBuilder sb = new StringBuilder("getProviderStatistics");
		return sb.toString();
	}

	@Override
	public String getHistoryRequest(String startDate, String endDate) {
		StringBuilder sb = new StringBuilder("getHistory/");
		sb.append("?");
		sb.append("startDate=");
		sb.append(startDate);
		sb.append("&endDate=");
		sb.append(endDate);
		return sb.toString();
	}
}